<template>
  <single-panel>
    <ob-table
      :columns="agentsColumns"
      :functionalPanel="true"
      :remote-opt="{
        method: getAgents,
      }"
      :tableLayoutFixed="false"
      :isSmartPagination="false"
      data-qa="LogisticDomainsAgentsTable"
      @select="onSelect"
      ref="obTableAllAgents"
      is-fixed-header
      :is-functional-sort="false"
      :is-functional-group="false"
    >
      <template v-slot:type="{ data }">
        <i :class="['icon', $options.rolesMap[data.item.roleCode]]"></i>
      </template>
      <template v-slot:status="{ data }">
        <div
          :class="['status', data.item.status === 'онлайн' ? 'is-online' : '']"
        >
          {{ data.item.status }}
        </div>
      </template>
      <template v-slot:risk="{ data }">
        <i :class="['icon', $options.riskColorsMap[data.item.riskColor]]"></i>
      </template>
      <template v-slot:linkType="{ data }">
        <div class="link">
          <i :class="['icon', $options.linkTypesMap[data.item.linkType]]"></i>
        </div>
      </template>
      <template slot="noneContent">
        <div class="no-content">
          <p>no content</p>
        </div>
      </template>
    </ob-table>

    <ob-modal
      ref="agentModal"
      size="medium"
      isShowControls
      okText="Выбрать"
      cancelText="Закрыть"
      customClass="all-agents-info-modal"
    >
      <div class="title" slot="title" v-if="activeAgent">
        <div class="title__second">
          {{ $options.rolesTitlesMap[activeAgent.roleCode] }}
          <!-- <span
            :class="[
              'status',
              activeAgent.status === 'онлайн' ? 'is-online' : '',
            ]"
          >
            {{ activeAgent.status }}
          </span> -->
        </div>
        <div class="ob-ty-modal-title">
          <i :class="['icon', $options.rolesMap[activeAgent.roleCode]]"></i>
          {{ activeAgent.title }}
        </div>
      </div>
      <agent-info :agent="activeAgent" />
    </ob-modal>
  </single-panel>
</template>

<script>
import api from "@/api";
import { mapActions } from "vuex";
import SinglePanel from "common-components/src/obComponents/obSinglePanels";
import ObTable from "common-components/src/obComponents/obTable";
import ObModal from "common-components/src/obComponents/obModal";
import AgentInfo from "./components/agentInfo";

export default {
  name: "logistic_domains_all",

  rolesMap: {
    CLIENT: "role-client",
    CLICAR: "role-domain-owner",
    CARRIER: "truck-sm",
  },

  rolesTitlesMap: {
    CLIENT: "Клиент",
    CLICAR: "Экспедитор",
    CARRIER: "Перевозчик",
  },

  riskColorsMap: {
    GREEN: "risk-1-blue",
    BLUE: "risk-2-green",
    YELLOW: "risk-3-yellow",
    ORANGE: "risk-4-orange",
    RED: "risk-5-red",
    BLACK: "risk-6-black",
  },

  linkTypesMap: {
    HANDSHAKE: "handshake",
    CONTRACT: "document",
    VAN: "close",
  },

  components: {
    SinglePanel,
    ObTable,
    ObModal,
    AgentInfo,
  },

  data() {
    return {
      activeAgent: null,
    };
  },

  computed: {
    agentsColumns() {
      return [
        {
          title: "Тип",
          key: "roleCode",
          slotName: "type",
        },
        {
          title: "название контрагента",
          key: "title",
        },
        {
          title: "присутствие в системе",
          key: "status",
          slotName: "status",
        },
        {
          title: "группа риска",
          key: "riskColor",
          slotName: "risk",
        },
        {
          title: "рейтинг",
          key: "rating",
        },
        {
          title: "скоринг",
          key: "scoring",
        },
        {
          title: "тип линка",
          key: "linkType",
          slotName: "linkType",
        },
        {
          title: "инн",
          key: "inn",
        },
        {
          title: "телефон",
          key: "phone",
        },
        {
          title: "эл. почта",
          key: "email",
        },
        {
          title: "юридический адрес",
          key: "legalAddress",
        },
        {
          title: "описание",
          key: "description",
        }
      ];
    },
  },

  methods: {
    ...mapActions({
      setGeneralInfo: 'logdomains/setGeneralInfo'
    }),
    async getAgents({ page, size, sort = "title,desc", query }) {
      const altSort = sort?.split(",");
      try {
        let res = await api.linkBrowser.getAllAgents({
          page,
          size,
          sort: altSort[0],
          direction: altSort[1].toUpperCase(),
          query,
        });

        res.content = res.content.map((item) => {
          return { ...item, status: "—", description: "—" };
        });
        return res;
      } catch (err) {
        console.error(err);
      }
    },

    async onSelect(agent) {
      await this.getAgent(agent.uuid);
      this.$refs.agentModal.open();
    },

    async getAgent(uuid) {
      const res = await api.linkBrowser.getAgent(uuid);
      this.activeAgent = res;
      this.setGeneralInfo(res);
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.left {
  margin: 20px;
}

.is-online {
  color: $deep-blue;
}

.link {
  color: $color-blue-navy-blue;
}

.title {
  i {
    color: $color-blue-smalt;
  }
}

.title__second {
  display: flex;

  span {
    margin-left: 10px;
  }
}

.no-content {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;

  p {
    @include font-mixin(24px, 40px, 400, $color-grey-span);
  }

  a {
    margin-top: 20px;
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
    text-decoration: none;
  }
}

::v-deep {
  td:first-child i {
    color: $color-blue-navy-blue;
  }
  td:nth-child(7) > .td-container {
    justify-content: center;
  }
}
</style>

<style>

.all-agents-info-modal .form-controls__left button:first-child {
  display: none;
}

</style>
